/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { IRegistrable } from "./registrable";
export declare function Directive(parameters: IDirective): <T>(constructor: {
    new (...args: any[]): T;
}) => void;
export interface IDirective extends IRegistrable {
    factory?: Function;
    controller?: Function;
    controllerAs?: string;
    templateUrl?: string;
    template?: string;
    bindings?: {
        [property: string]: string;
    };
    transclude?: boolean | {
        [slot: string]: string;
    };
    restrict?: "A" | "E" | "EA";
    require?: string | string[] | {
        [controller: string]: string;
    };
}
export declare const scopeInfoKey = "$scopeInfo";
