"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var registrable_1 = require("./registrable");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
function Service(parameters) {
    if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters))
        parameters = {};
    return function (constructor) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(constructor))
            throw new Error("Missing service constructor.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            parameters.factory = constructor["factory"];
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.factory))
            throw new Error("Missing service factory.");
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.name))
            parameters.name = paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(constructor);
        constructor[registrable_1.registrableMetadataKey] = parameters;
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(parameters.module)) {
            parameters.module.registerService(constructor);
        }
    };
}
exports.Service = Service;
