"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var $ = require("jquery");
var ScrollToggleClassDirective = /** @class */ (function (_super) {
    tslib_1.__extends(ScrollToggleClassDirective, _super);
    function ScrollToggleClassDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ScrollToggleClassDirective_1 = ScrollToggleClassDirective;
    ScrollToggleClassDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var self = this;
        function updateElement() {
            self.updateElement(instanceElement, instanceAttributes);
        }
        $(window).on("scroll.scrollToggleClass", updateElement);
        this.updateElement(instanceElement, instanceAttributes);
    };
    ScrollToggleClassDirective.prototype.updateElement = function (element, instanceAttributes) {
        var options = {};
        this.tryGetNumber(options, instanceAttributes, "minPos");
        this.tryGetNumber(options, instanceAttributes, "maxPos");
        this.tryGet(options, instanceAttributes, "cssClass");
        options.minPos = options.minPos || Number.MIN_VALUE;
        options.maxPos = options.maxPos || Number.MAX_VALUE;
        var scroll = $(window).scrollTop();
        if (scroll >= options.minPos && scroll <= options.maxPos)
            element.addClass(options.cssClass);
        else
            element.removeClass(options.cssClass);
    };
    ScrollToggleClassDirective.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        $(window).unbind("scroll.scrollToggleClass");
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    ScrollToggleClassDirective.factory = function () {
        return new ScrollToggleClassDirective_1();
    };
    ScrollToggleClassDirective = ScrollToggleClassDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "scrollToggleClass",
            restrict: "A"
        })
    ], ScrollToggleClassDirective);
    return ScrollToggleClassDirective;
    var ScrollToggleClassDirective_1;
}(base_directive_1.DirectiveBase));
exports.ScrollToggleClassDirective = ScrollToggleClassDirective;
