"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_directive_1 = require("./base.directive");
var directive_1 = require("../decorators/directive");
var $ = require("jquery");
var SelectToggleClassDirective = /** @class */ (function (_super) {
    tslib_1.__extends(SelectToggleClassDirective, _super);
    function SelectToggleClassDirective() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SelectToggleClassDirective_1 = SelectToggleClassDirective;
    SelectToggleClassDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var className = instanceAttributes["selectToggleClass"];
        function documentClick() {
            instanceElement.removeClass(className);
        }
        $("html").on("click.selectToggleClass", documentClick);
        instanceElement.on("click", function (e) {
            e.stopPropagation();
            instanceElement.toggleClass(className);
        });
    };
    SelectToggleClassDirective.prototype.dispose = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        $("html").unbind("click.selectToggleClass");
        _super.prototype.dispose.call(this, scope, instanceElement, instanceAttributes, controller, transclude);
    };
    SelectToggleClassDirective.factory = function () {
        return new SelectToggleClassDirective_1();
    };
    SelectToggleClassDirective = SelectToggleClassDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "selectToggleClass",
            restrict: "A"
        })
    ], SelectToggleClassDirective);
    return SelectToggleClassDirective;
    var SelectToggleClassDirective_1;
}(base_directive_1.DirectiveBase));
exports.SelectToggleClassDirective = SelectToggleClassDirective;
