"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var InterceptorBase = /** @class */ (function () {
    function InterceptorBase(q) {
        var _this = this;
        this.q = q;
        this.request = function (c) { return _this.onRequest(c); };
        this.response = function (r) { return _this.onResponse(r); };
        this.requestError = function (r) { return _this.onRequestError(r); };
        this.responseError = function (r) { return _this.onResponseError(r); };
    }
    InterceptorBase.prototype.onRequest = function (config) {
        return config;
    };
    InterceptorBase.prototype.onResponse = function (response) {
        return this.q.resolve(response);
    };
    InterceptorBase.prototype.onRequestError = function (rejection) {
        return this.q.reject(rejection);
    };
    InterceptorBase.prototype.onResponseError = function (rejection) {
        return this.q.reject(rejection);
    };
    return InterceptorBase;
}());
exports.InterceptorBase = InterceptorBase;
