"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var angular_service_1 = require("./angular.service");
var base_service_1 = require("./base.service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var service_1 = require("../decorators/service");
var registrable_1 = require("../decorators/registrable");
var InjectorService = /** @class */ (function (_super) {
    tslib_1.__extends(InjectorService, _super);
    function InjectorService(injector) {
        var _this = _super.call(this) || this;
        _this.injector = injector;
        return _this;
    }
    InjectorService_1 = InjectorService;
    InjectorService.prototype.get = function (service) {
        if (paradigm_ui_web_shared_1.ObjectExtensions.isNull(service))
            return null;
        if (paradigm_ui_web_shared_1.ObjectExtensions.getTypeName(service) === "String")
            return this.injector.get(service);
        return this.injector.get(registrable_1.getRegistrableName(service) ||
            paradigm_ui_web_shared_1.FunctionExtensions.getFunctionName(service));
    };
    InjectorService.factory = function (injector) {
        return new InjectorService_1(injector);
    };
    InjectorService = InjectorService_1 = tslib_1.__decorate([
        service_1.Service({ name: "$pd-injectorService", dependencies: [angular_service_1.AngularServices.injector] })
    ], InjectorService);
    return InjectorService;
    var InjectorService_1;
}(base_service_1.ServiceBase));
exports.InjectorService = InjectorService;
