/// <reference types="angular" />
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { ServiceBase } from "./base.service";
import { Dictionary } from "@miracledevs/paradigm-ui-web-shared";
import { IController } from "../decorators/controller";
export declare class ModalService extends ServiceBase {
    private $rootScope;
    private $q;
    private $http;
    private $templateCache;
    private $compile;
    private $controller;
    readonly modals: Dictionary<ModalInstance, ng.IAugmentedJQuery>;
    constructor($rootScope: ng.IRootScopeService, $q: ng.IQService, $http: ng.IHttpService, $templateCache: ng.ITemplateCacheService, $compile: ng.ICompileService, $controller: ng.IControllerService);
    open(dialog: IController | Function, parameters?: any, staticDialog?: boolean, keyboard?: boolean): ModalInstance;
    close(modalInstance: ModalInstance, reason?: string): void;
    resolve<T>(modalInstance: ModalInstance, result: T): void;
    private openModal(dialogInfo, parameters, modalInstance, template, staticDialog, keyboard);
    private removeModal(modalInstance, modal);
    static factory($rootScope: ng.IRootScopeService, $q: ng.IQService, $http: ng.IHttpService, $templateCache: ng.ITemplateCacheService, $compile: ng.ICompileService, $controller: ng.IControllerService): ModalService;
}
export declare class ModalInstance {
    private readonly modalService;
    deferred: ng.IDeferred<any>;
    promise: ng.IPromise<any>;
    dispose: () => void;
    constructor(modalService: ModalService, deferred: ng.IDeferred<any>);
    close(reason?: string): void;
    resolve(result: any): void;
}
export declare const ModalParameters = "ModalParameters";
